/* ide-vala-diagnostics.c generated by valac 0.46.2, the Vala compiler
 * generated from ide-vala-diagnostics.vala, do not modify */

/* ide-vala-diagnostics.vala
 *
 * Copyright 2015 Christian Hergert <christian@hergert.me>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>
#include "libide-code.h"
#include "libide-core.h"
#include "libide-debugger.h"
#include "libide-editor.h"
#include "libide-foundry.h"
#include "libide-greeter.h"
#include "libide-gui.h"
#include "libide-io.h"
#include "libide-lsp.h"
#include "libide-plugins.h"
#include "libide-projects.h"
#include "libide-search.h"
#include "libide-sourceview.h"
#include "libide-terminal.h"
#include "libide-threading.h"
#include "libide-tree.h"
#include "libide-vcs.h"
#include <gio/gio.h>

#define IDE_TYPE_VALA_DIAGNOSTICS (ide_vala_diagnostics_get_type ())
#define IDE_VALA_DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnostics))
#define IDE_VALA_DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnosticsClass))
#define IDE_IS_VALA_DIAGNOSTICS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IDE_TYPE_VALA_DIAGNOSTICS))
#define IDE_IS_VALA_DIAGNOSTICS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IDE_TYPE_VALA_DIAGNOSTICS))
#define IDE_VALA_DIAGNOSTICS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnosticsClass))

typedef struct _IdeValaDiagnostics IdeValaDiagnostics;
typedef struct _IdeValaDiagnosticsClass IdeValaDiagnosticsClass;
typedef struct _IdeValaDiagnosticsPrivate IdeValaDiagnosticsPrivate;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _IdeValaDiagnostics {
	ValaReport parent_instance;
	IdeValaDiagnosticsPrivate * priv;
};

struct _IdeValaDiagnosticsClass {
	ValaReportClass parent_class;
};

struct _IdeValaDiagnosticsPrivate {
	GHashTable* diagnosed_files;
};

static gint IdeValaDiagnostics_private_offset;
static gpointer ide_vala_diagnostics_parent_class = NULL;

GType ide_vala_diagnostics_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IdeValaDiagnostics, vala_report_unref)
void ide_vala_diagnostics_clear (IdeValaDiagnostics* self);
static void _g_free0_ (gpointer var);
static void _vala_iterable_unref0_ (gpointer var);
static void ide_vala_diagnostics_add (IdeValaDiagnostics* self,
                               ValaSourceReference* source_reference,
                               const gchar* message,
                               IdeDiagnosticSeverity severity);
IdeDiagnostics* ide_vala_diagnostics_get_diagnostic_from_file (IdeValaDiagnostics* self,
                                                               const gchar* filename);
static void _g_object_unref0_ (gpointer var);
static void ide_vala_diagnostics_real_note (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_depr (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_warn (ValaReport* base,
                                     ValaSourceReference* source_reference,
                                     const gchar* message);
static void ide_vala_diagnostics_real_err (ValaReport* base,
                                    ValaSourceReference* source_reference,
                                    const gchar* message);
IdeValaDiagnostics* ide_vala_diagnostics_new (void);
IdeValaDiagnostics* ide_vala_diagnostics_construct (GType object_type);
static void ide_vala_diagnostics_finalize (ValaReport * obj);

static inline gpointer
ide_vala_diagnostics_get_instance_private (IdeValaDiagnostics* self)
{
	return G_STRUCT_MEMBER_P (self, IdeValaDiagnostics_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_vala_iterable_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL));
}

void
ide_vala_diagnostics_clear (IdeValaDiagnostics* self)
{
	GHashTable* _tmp0_;
	GHashFunc _tmp2_;
	GEqualFunc _tmp3_;
	GHashTable* _tmp4_;
	g_return_if_fail (self != NULL);
	((ValaReport*) self)->errors = 0;
	((ValaReport*) self)->warnings = 0;
	_tmp0_ = self->priv->diagnosed_files;
	if (_tmp0_ != NULL) {
		GHashTable* _tmp1_;
		_tmp1_ = self->priv->diagnosed_files;
		g_hash_table_remove_all (_tmp1_);
	}
	_tmp2_ = g_str_hash;
	_tmp3_ = g_str_equal;
	_tmp4_ = g_hash_table_new_full (_tmp2_, _tmp3_, _g_free0_, _vala_iterable_unref0_);
	_g_hash_table_unref0 (self->priv->diagnosed_files);
	self->priv->diagnosed_files = _tmp4_;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static void
ide_vala_diagnostics_add (IdeValaDiagnostics* self,
                          ValaSourceReference* source_reference,
                          const gchar* message,
                          IdeDiagnosticSeverity severity)
{
	const gchar* filename = NULL;
	ValaSourceFile* _tmp0_;
	ValaSourceFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* file = NULL;
	ValaArrayList* diagnosed_file = NULL;
	GHashTable* _tmp4_;
	const gchar* _tmp5_;
	gconstpointer _tmp6_;
	ValaArrayList* _tmp7_;
	IdeLocation* begin = NULL;
	GFile* _tmp24_;
	ValaSourceLocation _tmp25_ = {0};
	ValaSourceLocation _tmp26_;
	ValaSourceLocation _tmp27_ = {0};
	ValaSourceLocation _tmp28_;
	IdeLocation* _tmp29_;
	IdeLocation* end = NULL;
	GFile* _tmp30_;
	ValaSourceLocation _tmp31_ = {0};
	ValaSourceLocation _tmp32_;
	ValaSourceLocation _tmp33_ = {0};
	ValaSourceLocation _tmp34_;
	IdeLocation* _tmp35_;
	IdeDiagnostic* diag = NULL;
	IdeLocation* _tmp36_;
	IdeDiagnostic* _tmp37_;
	IdeDiagnostic* _tmp38_;
	IdeLocation* _tmp39_;
	IdeLocation* _tmp40_;
	IdeRange* _tmp41_;
	ValaArrayList* _tmp42_;
	IdeDiagnostic* _tmp43_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	if (source_reference == NULL) {
		return;
	}
	_tmp0_ = vala_source_reference_get_file (source_reference);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_source_file_get_filename (_tmp1_);
	_tmp3_ = _tmp2_;
	filename = _tmp3_;
	_tmp4_ = self->priv->diagnosed_files;
	_tmp5_ = filename;
	_tmp6_ = g_hash_table_lookup (_tmp4_, _tmp5_);
	diagnosed_file = (ValaArrayList*) _tmp6_;
	_tmp7_ = diagnosed_file;
	if (_tmp7_ != NULL) {
		ValaArrayList* _tmp8_;
		gpointer _tmp9_;
		IdeDiagnostic* _tmp10_;
		IdeLocation* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		_tmp8_ = diagnosed_file;
		_tmp9_ = vala_list_get ((ValaList*) _tmp8_, 0);
		_tmp10_ = (IdeDiagnostic*) _tmp9_;
		_tmp11_ = ide_diagnostic_get_location (_tmp10_);
		_tmp12_ = ide_location_get_file (_tmp11_);
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_g_object_unref0 (file);
		file = _tmp13_;
		_g_object_unref0 (_tmp10_);
	} else {
		const gchar* _tmp14_;
		GFile* _tmp15_;
		ValaArrayList* list = NULL;
		GEqualFunc _tmp16_;
		ValaArrayList* _tmp17_;
		GHashTable* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		ValaArrayList* _tmp21_;
		ValaArrayList* _tmp22_;
		ValaArrayList* _tmp23_;
		_tmp14_ = filename;
		_tmp15_ = g_file_new_for_path (_tmp14_);
		_g_object_unref0 (file);
		file = _tmp15_;
		_tmp16_ = g_direct_equal;
		_tmp17_ = vala_array_list_new (ide_diagnostic_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp16_);
		list = _tmp17_;
		_tmp18_ = self->priv->diagnosed_files;
		_tmp19_ = filename;
		_tmp20_ = g_strdup (_tmp19_);
		_tmp21_ = list;
		_tmp22_ = _vala_iterable_ref0 (_tmp21_);
		g_hash_table_insert (_tmp18_, _tmp20_, _tmp22_);
		_tmp23_ = list;
		diagnosed_file = _tmp23_;
		_vala_iterable_unref0 (list);
	}
	_tmp24_ = file;
	vala_source_reference_get_begin (source_reference, &_tmp25_);
	_tmp26_ = _tmp25_;
	vala_source_reference_get_begin (source_reference, &_tmp27_);
	_tmp28_ = _tmp27_;
	_tmp29_ = ide_location_new (_tmp24_, _tmp26_.line - 1, _tmp28_.column - 1);
	begin = _tmp29_;
	_tmp30_ = file;
	vala_source_reference_get_end (source_reference, &_tmp31_);
	_tmp32_ = _tmp31_;
	vala_source_reference_get_end (source_reference, &_tmp33_);
	_tmp34_ = _tmp33_;
	_tmp35_ = ide_location_new (_tmp30_, _tmp32_.line - 1, _tmp34_.column - 1);
	end = _tmp35_;
	_tmp36_ = begin;
	_tmp37_ = ide_diagnostic_new (severity, message, _tmp36_);
	diag = _tmp37_;
	_tmp38_ = diag;
	_tmp39_ = begin;
	_tmp40_ = end;
	_tmp41_ = ide_range_new (_tmp39_, _tmp40_);
	ide_diagnostic_take_range (_tmp38_, _tmp41_);
	_tmp42_ = diagnosed_file;
	_tmp43_ = diag;
	vala_collection_add ((ValaCollection*) _tmp42_, _tmp43_);
	_g_object_unref0 (diag);
	_g_object_unref0 (end);
	_g_object_unref0 (begin);
	_g_object_unref0 (file);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

IdeDiagnostics*
ide_vala_diagnostics_get_diagnostic_from_file (IdeValaDiagnostics* self,
                                               const gchar* filename)
{
	ValaArrayList* diagnosed_file = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	gint _tmp2_ = 0;
	ValaArrayList* _tmp3_;
	GPtrArray* ar = NULL;
	GPtrArray* _tmp7_;
	ValaArrayList* _tmp8_;
	GPtrArray* _tmp19_;
	IdeDiagnostics* _tmp20_;
	IdeDiagnostics* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = self->priv->diagnosed_files;
	_tmp1_ = g_hash_table_lookup (_tmp0_, filename);
	diagnosed_file = (ValaArrayList*) _tmp1_;
	_tmp3_ = diagnosed_file;
	if (_tmp3_ != NULL) {
		ValaArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		_tmp4_ = diagnosed_file;
		_tmp5_ = vala_collection_get_size ((ValaCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _tmp6_;
	} else {
		_tmp2_ = 0;
	}
	_tmp7_ = g_ptr_array_new_full ((guint) _tmp2_, _g_object_unref0_);
	ar = _tmp7_;
	_tmp8_ = diagnosed_file;
	if (_tmp8_ != NULL) {
		{
			ValaArrayList* _diag_list = NULL;
			ValaArrayList* _tmp9_;
			ValaArrayList* _tmp10_;
			gint _diag_size = 0;
			ValaArrayList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _diag_index = 0;
			_tmp9_ = diagnosed_file;
			_tmp10_ = _vala_iterable_ref0 (_tmp9_);
			_diag_list = _tmp10_;
			_tmp11_ = _diag_list;
			_tmp12_ = vala_collection_get_size ((ValaCollection*) _tmp11_);
			_tmp13_ = _tmp12_;
			_diag_size = _tmp13_;
			_diag_index = -1;
			while (TRUE) {
				IdeDiagnostic* diag = NULL;
				ValaArrayList* _tmp14_;
				gpointer _tmp15_;
				GPtrArray* _tmp16_;
				IdeDiagnostic* _tmp17_;
				IdeDiagnostic* _tmp18_;
				_diag_index = _diag_index + 1;
				if (!(_diag_index < _diag_size)) {
					break;
				}
				_tmp14_ = _diag_list;
				_tmp15_ = vala_list_get ((ValaList*) _tmp14_, _diag_index);
				diag = (IdeDiagnostic*) _tmp15_;
				_tmp16_ = ar;
				_tmp17_ = diag;
				_tmp18_ = _g_object_ref0 (_tmp17_);
				g_ptr_array_add (_tmp16_, _tmp18_);
				_g_object_unref0 (diag);
			}
			_vala_iterable_unref0 (_diag_list);
		}
	}
	_tmp19_ = ar;
	_tmp20_ = ide_diagnostics_new_from_array (_tmp19_);
	result = _tmp20_;
	_g_ptr_array_unref0 (ar);
	return result;
}

static void
ide_vala_diagnostics_real_note (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_NOTE);
}

static void
ide_vala_diagnostics_real_depr (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_DEPRECATED);
	((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
}

static void
ide_vala_diagnostics_real_warn (ValaReport* base,
                                ValaSourceReference* source_reference,
                                const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_WARNING);
	((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
}

static void
ide_vala_diagnostics_real_err (ValaReport* base,
                               ValaSourceReference* source_reference,
                               const gchar* message)
{
	IdeValaDiagnostics * self;
	self = (IdeValaDiagnostics*) base;
	g_return_if_fail (message != NULL);
	ide_vala_diagnostics_add (self, source_reference, message, IDE_DIAGNOSTIC_ERROR);
	((ValaReport*) self)->errors = ((ValaReport*) self)->errors + 1;
}

IdeValaDiagnostics*
ide_vala_diagnostics_construct (GType object_type)
{
	IdeValaDiagnostics* self = NULL;
	self = (IdeValaDiagnostics*) vala_report_construct (object_type);
	return self;
}

IdeValaDiagnostics*
ide_vala_diagnostics_new (void)
{
	return ide_vala_diagnostics_construct (IDE_TYPE_VALA_DIAGNOSTICS);
}

static void
ide_vala_diagnostics_class_init (IdeValaDiagnosticsClass * klass,
                                 gpointer klass_data)
{
	ide_vala_diagnostics_parent_class = g_type_class_peek_parent (klass);
	((ValaReportClass *) klass)->finalize = ide_vala_diagnostics_finalize;
	g_type_class_adjust_private_offset (klass, &IdeValaDiagnostics_private_offset);
	((ValaReportClass *) klass)->note = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_note;
	((ValaReportClass *) klass)->depr = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_depr;
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_warn;
	((ValaReportClass *) klass)->err = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) ide_vala_diagnostics_real_err;
}

static void
ide_vala_diagnostics_instance_init (IdeValaDiagnostics * self,
                                    gpointer klass)
{
	self->priv = ide_vala_diagnostics_get_instance_private (self);
}

static void
ide_vala_diagnostics_finalize (ValaReport * obj)
{
	IdeValaDiagnostics * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IDE_TYPE_VALA_DIAGNOSTICS, IdeValaDiagnostics);
	_g_hash_table_unref0 (self->priv->diagnosed_files);
	VALA_REPORT_CLASS (ide_vala_diagnostics_parent_class)->finalize (obj);
}

GType
ide_vala_diagnostics_get_type (void)
{
	static volatile gsize ide_vala_diagnostics_type_id__volatile = 0;
	if (g_once_init_enter (&ide_vala_diagnostics_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdeValaDiagnosticsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ide_vala_diagnostics_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdeValaDiagnostics), 0, (GInstanceInitFunc) ide_vala_diagnostics_instance_init, NULL };
		GType ide_vala_diagnostics_type_id;
		ide_vala_diagnostics_type_id = g_type_register_static (VALA_TYPE_REPORT, "IdeValaDiagnostics", &g_define_type_info, 0);
		IdeValaDiagnostics_private_offset = g_type_add_instance_private (ide_vala_diagnostics_type_id, sizeof (IdeValaDiagnosticsPrivate));
		g_once_init_leave (&ide_vala_diagnostics_type_id__volatile, ide_vala_diagnostics_type_id);
	}
	return ide_vala_diagnostics_type_id__volatile;
}

